<?php
/*
Plugin Name: Twitter Connect
Author:  Denis
Author URI: http://fairyfish.net/
Plugin URI: http://fairyfish.net/
Description: Integrate Twitter and Wordpress.  Provides single-signon using oAuth and displays Twitter avatars.
Version: 1.0
*/
include dirname(__FILE__).'/twitterOAuth.php';
include dirname(__FILE__).'/secret.php';

add_action('init', 'twc_init');
add_filter("get_avatar", "twc_get_avatar",10,4);
add_action("wp_head", "twc_wp_head");
add_action('comment_post', 'post_comment_to_twitter',1000);

$twc_loaded = false;

function twit_connect(){
    global $twc_loaded;
    if($twc_loaded){
        return;
    }
    twc_show_twit_connect_button();
    $twc_loaded = true;
}

function twc_wp_head(){
    if(is_user_logged_in()) {
        if(isset($_GET['oauth_token'])){
            echo '<script type="text/javascript">window.opener.twc_bookmark("");window.close();</script>';
        }  
    }
}

function twc_show_twit_connect_button($id='0'){
    global $twc_loaded, $user_email;

    /*if(is_user_logged_in()){
        echo '<p>Your email address is '.'<a name="twcbutton" href="'.get_option('siteurl').'/wp-admin/profile.php">'.$user_email.'</a>.</p>';
    }*/

    if($twc_loaded || is_user_logged_in()) {
        return;
    }
	
	$twc_url = WP_PLUGIN_URL.'/twitter-connect';
	$twc_page = 'start.php';
	/*
	$twc_url = 'http://mytweeple.com';
	$twc_page = 'twc.aspx';
	$twc_a = 'location.href+"#twcbutton"';
	*/

	$twc_btn_image = "http://s3.amazonaws.com/static.whitleymedia/twitter_button_1_lo.gif";

    echo '<style id="twc_styles_text" type="text/css">
        #twc_connect button{ 
        margin:0 7px 0 0; 
        background:none; 
        border:none; 
        cursor:pointer; 
        padding:5px 10px 6px 7px; /* Links */
		} 
        #twc_connect button{ 
        width:auto; 
        overflow:visible; 
        padding:4px 10px 3px 7px; /* IE6 */ 
        } 
        twc_connect button img{ 
        margin:0 3px -3px 0 !important; 
        padding:0; 
        border:none; 
        width:16px; 
        height:16px;
		}
    </style>';

    echo '<div id="twc_connect"></div>';

    echo 
	'<script type="text/javascript">
    function twc_bookmark(){
       var url=location.href;
       var temp = url.split("#");
       url = temp[0];
       url += "#twcbutton";
       location.href = url;
       location.reload();
    }
    if(document.getElementById("twc_connect")){
        var button = document.createElement("button");
        button.id = "twc_button";
        button.setAttribute("class","btn");
        button.onclick = function(){window.open("'.$twc_url.'/'.$twc_page.'", "twcWindow","width=800,height=400,left=150,top=100,scrollbar=no,resize=no");return false;};
        button.innerHTML = "<img src=\''.$twc_btn_image.'\' style=\'margin:0;\'>";
        document.getElementById("twc_connect").appendChild(button);
	}
	</script>';

    $twc_loaded = true;
}


function twc_init()
{
    if(!is_user_logged_in()) {
        if(isset($_GET['oauth_token'])){
            twc_EpiConfirm();
        }
    }

}

function twc_get_avatar($avatar, $id_or_email='',$size='32') {
  global $comment;

  if(is_object($comment)) {
      $id_or_email = $comment->user_id;
  }

  if (is_object($id_or_email)){
     $id_or_email = $id_or_email->user_id;
  }

  if (get_usermeta($id_or_email, 'twcid')) {
    $user_info = get_userdata($id_or_email);
    $out = 'http://purl.org/net/spiurl/'.$user_info->user_login;
    $avatar = "<img alt='' src='{$out}' class='avatar avatar-{$size}' height='{$size}' width='{$size}' />";
    return $avatar;
  } else {
    return $avatar;
  }
}

function twc_EpiConfirm(){
    global $consumer_key, $consumer_secret;
	
	/* Create TwitterOAuth object with app key/secret and token key/secret from default phase */
	$to = new TwitterOAuth($consumer_key, $consumer_secret, $_GET['oauth_token'],$_GET['oauth_token_secret']);
	
	/* Request access tokens from twitter */
	$tok = $to->getAccessToken();

	/* Create TwitterOAuth with app key/secret and user access key/secret */
	$to = new TwitterOAuth($consumer_key, $consumer_secret, $tok['oauth_token'], $tok['oauth_token_secret']);
	
	/* Run request on twitter API as user. */
	$twitterInfo = $to->OAuthRequest('https://twitter.com/account/verify_credentials.json', array(), 'GET');
	$twitterInfo = json_decode ($twitterInfo);
	
	/*
	$is_follow = $to->OAuthRequest('http://twitter.com/friendships/exists.json',array('user_a' => $twitterInfo->screen_name,'user_b'=>'nbatube'),'GET');
	
	if($is_follow != "true"){
		$to->OAuthRequest('http://twitter.com/friendships/create.json',array('screen_name' => 'nbatube','follow'=>'true'),'POST');
	}*/
	
	twc_Login($twitterInfo->id.'|'.$twitterInfo->screen_name.'|'.$twitterInfo->name.'|'.$twitterInfo->url.'|'.$tok['oauth_token'] .'|'.$tok['oauth_token_secret']); 
}

function twc_Login($pdvUserinfo) {
	global $twc_use_twitter_profile;

	$userinfo = explode('|',$pdvUserinfo);
	if(count($userinfo) < 6) {
		wp_die("An error occurred while trying to contact Twit Connect.");
	}

	$userdata = array(
		'user_pass' => wp_generate_password(),
		'user_login' => $userinfo[1],
		'display_name' => $userinfo[2],
		'user_url' => $userinfo[3],
		'user_email' => $userinfo[1].'@twitter.com'
	);

	if(!function_exists('wp_insert_user')){
		include_once( ABSPATH . WPINC . '/registration.php' );
	} 
  
	$wpuid = twc_twitteruser_to_wpuser($userinfo[0]);

	if(!$wpuid){
		if($userinfo[0]){
			$wpuid = wp_insert_user($userdata);
		
			if($wpuid){
				update_usermeta($wpuid, 'twcid', $userinfo[0]);
				$twc_array = array (
					"oauth_access_token" => $userinfo[4],
					"oauth_access_token_secret" => $userinfo[5],
				);
				update_usermeta($wpuid, 'twcdata', $twc_array);
			}
		}
	} else {
		$userdata = array(
			'ID' => $wpuid,
			'user_login' => $userinfo[1],
			'display_name' => $userinfo[2],
			'user_url' => $userinfo[3],
			'user_email' => $userinfo[1].'@twitter.com'
		);
		update_usermeta($wpuid, 'twcid', $userinfo[0]);
		$twc_array = array (
			"oauth_access_token" => $userinfo[4],
			"oauth_access_token_secret" => $userinfo[5],
		);
		update_usermeta($wpuid, 'twcdata', $twc_array);
	}
  
	if($wpuid) {
		wp_set_auth_cookie($wpuid, true, false);
		wp_set_current_user($wpuid);
	}
}

function twc_get_user_by_meta($meta_key, $meta_value) {
  global $wpdb;
  $sql = "SELECT user_id FROM $wpdb->usermeta WHERE meta_key = '%s' AND meta_value = '%s'";
  return $wpdb->get_var($wpdb->prepare($sql, $meta_key, $meta_value));
}

function twc_twitteruser_to_wpuser($twcid) {
  return twc_get_user_by_meta('twcid', $twcid);
}

function post_comment_to_twitter($id){
	global $user_ID;
	
	$twcdata = get_usermeta($user_ID, 'twcdata');
	
	if($twcdata){
		$comment_post_id = $_POST['comment_post_ID'];
		
		$permalink = get_permalink($comment_post_id)."#comment-$id";
	
		$comment_content = get_comment($id);
		$comment_content = $permalink .' '. $comment_content->comment_content;
		
		global $consumer_key, $consumer_secret;
		
		$to = new TwitterOAuth($consumer_key, $consumer_secret, $twcdata['oauth_access_token'], $twcdata['oauth_access_token_secret']);
		
		$resp = $to->OAuthRequest('https://twitter.com/statuses/update.json', array('status' => $comment_content), 'POST');
	}
}
?>